/*
 * d2c
 *
 * Device to cloud API
 *
 * API version: 0.1
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package easyplatform

import (
	"fmt"
	"net/http"
	"strings"

	"github.com/gorilla/mux"
)

type Route struct {
	Name        string
	Method      string
	Pattern     string
	HandlerFunc http.HandlerFunc
}

type Routes []Route

func NewRouter() *mux.Router {
	router := mux.NewRouter().StrictSlash(true)
	for _, route := range routes {
		var handler http.Handler
		handler = route.HandlerFunc
		handler = Logger(handler, route.Name)

		router.
			Methods(route.Method).
			Path(route.Pattern).
			Name(route.Name).
			Handler(handler)
	}

	return router
}

func Index(w http.ResponseWriter, r *http.Request) {
	fmt.Fprintf(w, "Hello World!")
}

var routes = Routes{
	Route{
		"Index",
		"GET",
		"/easy-platform/d2c/0.1/",
		Index,
	},

	Route{
		"AssistantRequest",
		strings.ToUpper("Post"),
		"/easy-platform/d2c/0.1/clouds/request",
		AssistantRequest,
	},

	Route{
		"GetCases",
		strings.ToUpper("Get"),
		"/easy-platform/d2c/0.1/cases",
		GetCases,
	},

	Route{
		"GetResultCases",
		strings.ToUpper("Get"),
		"/easy-platform/d2c/0.1/cases/{caseId}/result",
		GetResultCases,
	},

	Route{
		"UploadCase",
		strings.ToUpper("Post"),
		"/easy-platform/d2c/0.1/cases/registration",
		UploadCase,
	},
}
